"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = T;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/toConsumableArray"));

var _react = _interopRequireDefault(require("react"));

function T(props) {
  var Table = props.tableTag || 'table';
  var Thead = props.theadTag || 'thead';
  var Tbody = props.tbodyTag || 'tbody';
  var Tr = props.trTag || 'tr';
  var Td = props.tdTag || 'td';
  var Th = props.thTag || 'th';
  var headers = props.headers || sniffHeaders(props.data);
  var onHeaderClick = props.onHeaderClick || noop;
  var onDataClick = props.onDataClick || noop;
  var onRowSelect = props.onRowSelect || noop;
  return _react.default.createElement(Table, {
    className: props.className
  }, props.children ? props.children(props) : renderTableChildren());

  function renderTableChildren() {
    return _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(Thead, null, _react.default.createElement(Tr, {
      className: "headerRow"
    }, headers.map(function (header, i) {
      return _react.default.createElement(Th, {
        className: "header",
        key: "".concat(i).concat(header.name),
        tid: "header",
        onClick: function onClick() {
          return onHeaderClick(header.name, i);
        }
      }, header.render ? header.render(header.name) : header.name);
    }))), _react.default.createElement(Tbody, null, props.data && props.data.map(function (row, i) {
      return _react.default.createElement(Tr, Object.assign({
        className: "dataRow",
        key: i
      }, props.renderSelector && props.onRowSelect ? {} : {
        tid: 'rowSelector',
        onClick: function onClick() {
          return onRowSelect(row, i);
        }
      }), props.renderSelector && _react.default.createElement(Td, {
        tid: "rowSelector",
        onClick: function onClick() {
          return onRowSelect(row, i);
        }
      }, props.renderSelector(!!row.selected)), headers.map(function (header, j) {
        return _react.default.createElement(Td, {
          className: "data",
          key: "".concat(i).concat(header.name),
          tid: "data",
          onClick: function onClick() {
            return onDataClick(i, j, header.name, row[header.name]);
          }
        }, row.renderCell ? row.renderCell(row, header.name) : row[header.name]);
      }));
    })));
  }
}

function sniffHeaders(data) {
  return (0, _toConsumableArray2.default)(data.reduce(function (set, row) {
    Object.keys(row).filter(function (column) {
      return column !== 'renderCell' && column !== 'selected';
    }).forEach(function (column) {
      return set.add(column);
    });
    return set;
  }, new Set()).values()).map(function (name) {
    return {
      name: name
    };
  });
}

function noop() {}
